    DECLARE SUB RegisterObject (ObjectName$, ObjectKind%, TopRow%, LeftColumn%, BottomRow%, RightColumn%)
    DECLARE SUB Button (Handle%, msg%, wp%, lp&)
    DECLARE SUB Message (count%, msg%, wp%, lp&)
    DECLARE FUNCTION MouseInstalled% ()
    DECLARE FUNCTION MouseReset% ()
    DECLARE FUNCTION MousePressInfo% (Button%, Row%, Column%)
    DECLARE FUNCTION MouseReleaseInfo% (Button%, Row%, Column%)

    'Don't know how you will like this idea, but here goes.
    'If you think it is a good idea we could go further with it.
    'We can use the event driven mouse routines to set up an "object
    'oriented" way to handle routines. We act like a traffic cop
    'directing messages to the routines and the individual routines
    'act on these messages. The range of objects would be limited only
    'by what you could dream up.

    'Object types - these are the kinds of objects available
    'There would of couse be more than one. Some ideas are scroll bars,
    'edit boxes, list boxes, etc. I don't suppose you could guess where
    'these ideas are coming from.
    CONST tyBUTTON = 1

    'Messages - these are the types of messages we would be sending to
    'the routines.
    CONST msgCREATE = 1
    CONST msgMOUSEMOVE = 2
    CONST msgLBDOWN = 3
    CONST msgLBUP = 4
    CONST msgRBDOWN = 5
    CONST msgRBUP = 6

    TYPE ObjectType
      id AS STRING * 30
      tr AS INTEGER
      lc AS INTEGER
      br AS INTEGER
      rc AS INTEGER
      kind AS INTEGER
      enabled AS INTEGER
      priority AS INTEGER
    END TYPE
    COMMON SHARED /ourobjects/ Object()    AS ObjectType
    COMMON SHARED /ourobjects/ count%
    DIM Object(100) AS ObjectType
    DIM OurEvent%(8)
    COLOR , 0
    IF MouseInstalled% THEN
      'The following routine resets the mouse and returns the number of buttons.
      Buttons% = MouseReset%
    ELSE
      PRINT "Mouse IS NOT installed."
      END
    END IF
    CALL MousePointerOn                'To prevent mouse droppings


    CLS

    '====================================================================
    'here is what the user would actually be required to do to add a
    '"button" to his program.
    '====================================================================

    CALL RegisterObject("test", tyBUTTON, 2, 2, 5, 20)
    CALL RegisterObject("test1", tyBUTTON, 8, 7, 12, 17)
    CALL RegisterObject("test2", tyBUTTON, 10, 20, 22, 60)

    CALL MouseSetEvent(127)                  '2 + 16
    ON UEVENT GOSUB MouseEventHandler       'Point to an event hander
    UEVENT ON                               'Turn on event trapping.
    '-------------------------------------------------------------------
    'We sit here waiting for a mouse event. We would of course add key
    'events as well. At that time we would have to add focus so we would
    'know which object has the focus.
    '--------------------------------------------------------------------
    DO
    LOOP UNTIL INKEY$ <> ""
    UEVENT OFF
    END

MouseEventHandler:
  'A little steppin' and fetchin' cause the release doesn't trigger the
  'UEVENT.
  'IF MouseReleaseInfo%(WhichButton%, Row%, Col%) = 0 THEN
    CALL MouseGetEventInfo(EventFlag%, Lb%, Rb%, Cb%, Row%, Col%)
  'ELSE
  '  EventFlag% = 4
  'END IF
  GOSUB BreakOutEvents
  CALL MousePointerOff                'To prevent mouse droppings
  FOR i% = 1 TO count%
    IF Row% >= Object(i%).tr AND Row% <= Object(i%).br AND Col% >= Object(i%).lc AND Col% <= Object(i%).rc THEN
      FOR h% = 1 TO numberofevents%
        'send the messages to the objects - up to eight at a time
        CALL Message(i%, OurEvent%(h%), wp%, lp&)
      NEXT
      EXIT FOR
    END IF
  NEXT
  CALL MousePointerOn
RETURN

    '       1 = Any mouse movement
    '       2 = Left button pressed
    '       4 = Left button released
    '       8 = Right button pressed
    '      16 = Right button released
    '      32 = Center button pressed
    '      64 = Center button released
BreakOutEvents:
  numberofevents% = 0      'assume none
'  LOCATE 20, 1
'  PRINT EventFlag%
  IF EventFlag% > 0 THEN
    IF EventFlag% AND 1 THEN
      numberofevents% = NumberofEvent% + 1
      OurEvent%(numberofevents%) = msgMOUSEMOVE
    END IF
    IF EventFlag% AND 2 THEN
      numberofevents% = NumberofEvent% + 1
      OurEvent%(numberofevents%) = msgLBDOWN
    END IF
    IF EventFlag% AND 4 THEN
      numberofevents% = NumberofEvent% + 1
      OurEvent%(numberofevents%) = msgLBUP
    END IF
    IF EventFlag% > 7 THEN
      IF EventFlag% AND 8 THEN
        numberofevents% = NumberofEvent% + 1
        OurEvent%(numberofevents%) = msgRBDOWN
      END IF
      IF EventFlag% AND 16 THEN
        numberofevents% = NumberofEvent% + 1
        OurEvent%(numberofevents%) = msgRBUP
      END IF
      IF EventFlag% > 31 THEN
        'Check middle button here.
      END IF
    END IF
  END IF
RETURN

SUB Button (Handle%, msg%, wp%, lp&)
  'handle% - which button?
  'msg% - what do we do?
  'wp% - int data
  'lp& - long data

  'we can process any message here, including mouse down, up or movement
  'For an example of some of the "neat" things you could do, you could
  'detect a mousemovement here and then check the mouse cursor type and
  'change it to a special type that could be included in our ObjectType.
  'ie. we could add a Object.MouseType, and change to that type as the
  'mouse cursor moves over the window.

  SELECT CASE msg%
    CASE msgCREATE
      GOSUB DrawButtonUp
    CASE msgLBDOWN
      GOSUB DrawButtonDown
    CASE msgLBUP
      GOSUB DrawButtonUp
    CASE ELSE
  END SELECT

EXIT SUB

DrawButtonUp:
  'obviously handling color/mono type screens here would be a good idea
  'I'm just going to do color for the demonstration. we could also put the
  'colors in the type.
  fborder1% = 8
  bborder1% = 1
  fborder2% = 1
  bborder2% = 7
  fbody% = 1
  bbody% = 6
  tr% = Object(Handle%).tr
  lc% = Object(Handle%).lc
  br% = Object(Handle%).br
  rc% = Object(Handle%).rc
  wide% = rc% - lc% + 1
  LOCATE tr%, lc%
  COLOR fborder1%, bborder1%
  PRINT CHR$(219); CHR$(219);
  PRINT STRING$(wide% - 3, 219);
  COLOR fborder1%, bborder2%
  PRINT CHR$(223);
  FOR i% = tr% + 1 TO br% - 1
    LOCATE i%, lc%
    COLOR fborder1%, bborder1%
    PRINT CHR$(219); CHR$(219);
    COLOR fbody%, bbody%
    PRINT STRING$(wide% - 3, 219);
    COLOR fborder2%, bborder2%
    PRINT CHR$(32);
  NEXT
  LOCATE br%, lc%
  COLOR fborder1%, bborder1%
  PRINT CHR$(219);
  COLOR fborder1%, bborder2%
  PRINT CHR$(223);
  COLOR fborder2%, bborder2%
  PRINT STRING$(wide% - 3, 223);
  PRINT CHR$(32);
RETURN

DrawButtonDown:
  'obviously handling color/mono type screens here would be a good idea
  'I'm just going to do color for the demonstration. we could also put the
  'colors in the type.
  fborder1% = 9
  bborder1% = 7
  fborder2% = 9
  bborder2% = 8
  fbody% = 9
  bbody% = 0
  tr% = Object(Handle%).tr
  lc% = Object(Handle%).lc
  br% = Object(Handle%).br
  rc% = Object(Handle%).rc
  wide% = rc% - lc% + 1
  LOCATE tr%, lc%
  COLOR fborder1%, bborder1%
  PRINT CHR$(32);
  PRINT STRING$(wide% - 3, 220);
  COLOR bborder2%, bborder1%
  PRINT CHR$(220); CHR$(219);
  FOR i% = tr% + 1 TO br% - 1
    LOCATE i%, lc%
    COLOR fborder1%, bborder1%
    PRINT CHR$(32);
    COLOR fbody%, bbody%
    PRINT STRING$(wide% - 3, 219);
    COLOR bborder2%, fborder2%
    PRINT CHR$(219); CHR$(219);
  NEXT
  LOCATE br%, lc%
  COLOR bborder2%, bborder1%
  PRINT CHR$(220);
  COLOR bborder2%, fborder1%
  PRINT STRING$(wide% - 2, 219);
  PRINT CHR$(219);
RETURN

END SUB

SUB Message (count%, msg%, wp%, lp&)

  'count% is the object "handle"
  'msg% is what action
  'wp% is integer data
  'lp& is long data
  'we may need to add other parameters, such as reals, strings, arrays, etc.
  'in C you could get aroud that restiction by passing pointers in lp&,
  'oh well, sigh...

    SELECT CASE Object(count%).kind
      CASE tyBUTTON
        CALL Button(count%, msg%, wp%, lp&)
      CASE ELSE
    END SELECT
END SUB

SUB RegisterObject (ObjectName$, ObjectKind%, TopRow%, LeftColumn%, BottomRow%, RightColumn%)
  'ObjectName$ - Identifies this object.
  'ObjectType - Which code will we execute?
  'TopRow%     -\
  'LeftColumn% -  \ coordinates of the button.
  'BottomRow%  -  /
  'RightColumn%-/
  IF ObjectName$ <> "" THEN
    count% = count% + 1
    Object(count%).id = ObjectName$
    Object(count%).tr = TopRow%
    Object(count%).lc = LeftColumn%
    Object(count%).br = BottomRow%
    Object(count%).rc = RightColumn%
    Object(count%).kind = ObjectKind%
    Object(count%).enabled = -1
    Object(count%).priority = count%
  END IF
  CALL Message(count%, msgCREATE, wp%, lp&)

END SUB

