'MOUSETST.BAS
DEFINT A-Z
REM $INCLUDE: 'MOUSE.BI' 

CLS
PRINT "A Microsoft compatible mouse driver ";
IF MouseInstalled% THEN
    PRINT "IS installed."
ELSE
    PRINT "IS NOT installed."
    END
END IF

PRINT "It is ";
IF NOT MouseAlreadyReset% THEN
    PRINT "NOT ";
END IF
PRINT "already reset."

'The following routine resets the mouse and returns the number
'of buttons.
Buttons% = MouseReset%

'Get current mouse sensitivity settings
CALL MouseGetSensitivity(VertRatio%, HorizRatio%, DblSpd%)

'Get mouse hardware and software information
CALL MouseGetInfo(MajorV%, MinorV%, MouseType%, Irq%)

PRINT "The mouse has been initialized."
PRINT
PRINT "Mouse information:"
PRINT
PRINT "       Mouse Driver Version:";
PRINT USING "##.##"; MajorV% + MinorV% / 100
PRINT "                 Mouse Type: ";
SELECT CASE MouseType%
    CASE 1
        PRINT "Bus Mouse"
    CASE 2
        PRINT "Serial Mouse"
    CASE 3
        PRINT "InPort Mouse"
    CASE 4
        PRINT "PS/2 Mouse"
    CASE 5
        PRINT "HP Mouse"
    CASE ELSE
        PRINT "Beats the heck outta me!"
END SELECT
PRINT "      Number of Buttons:"; Buttons%
PRINT "               IRQ Line:"; Irq%
PRINT
PRINT "Current mouse settings:"
PRINT
PRINT "       Horizontal Ratio:"; HorizRatio%; "mickeys per 8 pixels"
PRINT "         Vertical Ratio:"; VertRatio%; "mickeys per 8 pixels"
PRINT " Double-speed Threshold:"; DblSpd%; "mickeys per second"
PRINT
PRINT "Press <Enter> to proceed or <Esc> to quit."

CALL MousePointerOn                 'Makes the mouse pointer visible
GOSUB WaitForEscOrEnter
GOSUB ClearScreen
PRINT
PRINT "You may now move the mouse around the screen. Press <P> to"
PRINT "toggle between Pixel and Row/Column coordinates. Press"
PRINT "<Enter> to proceed or press <Esc> to quit."
PRINT

StartRow% = CSRLIN                      'Current cursor position
PRINT "Mouse location (Vert/Horiz):"
PRINT "                Left Button:"
PRINT "               Right Button:"
IF Buttons% > 2 THEN
    PRINT "              Center button:"
END IF

CALL MousePointerOn                 'Makes the mouse pointer visible
DO
    A$ = UCASE$(INKEY$)
    SELECT CASE A$
        CASE CHR$(27)               'Esc
            GOTO MouseTestExit
        CASE CHR$(13)               'Enter
            EXIT DO
        CASE "P"
            Pixels% = Pixels% XOR -1    'Toggle the switch
            IF Pixels% THEN
                CALL MousePixelsOn
            ELSE
                CALL MousePixelsOff
            END IF
        CASE ELSE
    END SELECT
    CALL MouseGetStatus(Lb%, Rb%, Cb%, Row%, Column%)
    LOCATE StartRow%, 29
    PRINT STR$(Row%); ","; STR$(Column%); " (";
    IF Pixels% THEN
        PRINT "Pixels)      "
    ELSE
        PRINT "Row/Columns) "
    END IF
    LOCATE , 30
    IF Lb% THEN
        PRINT "Pressed    "
    ELSE
        PRINT "Not Pressed"
    END IF
    LOCATE , 30
    IF Rb% THEN
        PRINT "Pressed    "
    ELSE
        PRINT "Not Pressed"
    END IF
    IF Buttons% = 3 THEN
        LOCATE , 30
        IF Cb% THEN
            PRINT "Pressed    "
        ELSE
            PRINT "Not Pressed"
        END IF
    END IF
LOOP
CALL MousePixelsOff             'Back to row/column coordinates

DEF SEG = 0
ScreenRows% = PEEK(&H484) + 1   'Get rows from EGA/VGA data area
IF ScreenRows% = 1 THEN         'If it was zero (we added one)
    ScreenRows% = 25            'Then it must be a CGA/Mono - Only
END IF                          ' 25 rows are supported.
ScreenCols% = PEEK(&H44A)       'Get Screen columns from BIOS
DEF SEG

GOSUB ClearScreen
PRINT "You can now use the arrow keys position the mouse pointer."
PRINT "The MouseSetPointer routine is being utilized for this"
PRINT "purpose. Press <Enter> when you are ready to proceed to the"
PRINT "next part of the demo or press <Esc> to quit."
CALL MousePointerOn
DO
    DO
        A$ = INKEY$
    LOOP UNTIL LEN(A$)
    
    'In case you moved the mouse between key presses, Row% and Column%
    CALL MouseGetStatus(Lb%, Rb%, Cb%, Row%, Column%)
    SELECT CASE A$
        CASE CHR$(27)                   'Esc
            GOTO MouseTestExit
        CASE CHR$(13)                   'Enter
            EXIT DO
        CASE CHR$(0) + CHR$(72)         'Up arrow
            IF Row% > 1 THEN
                Row% = Row% - 1
            END IF
        CASE CHR$(0) + CHR$(80)         'Down arrow
            IF Row% < ScreenRows% THEN
                Row% = Row% + 1
            END IF
        CASE CHR$(0) + CHR$(75)         'Left arrow
            IF Column% > 1 THEN
                Column% = Column% - 1
            END IF
        CASE CHR$(0) + CHR$(77)         'Right arrow
            IF Column% < ScreenCols% THEN
                Column% = Column% + 1
            END IF
        CASE ELSE
            BEEP
    END SELECT
    CALL MouseSetPointer(Row%, Column%)
LOOP

GOSUB ClearScreen
PRINT "We can even tell you where a specific mouse button was pressed"
PRINT "or released, and how many times. For the next 10 seconds, move"
PRINT "the mouse around pressing and releasing the left button. At"
PRINT "the end of that time, we'll tell you how many times it was"
PRINT "pressed and released, and where the mouse pointer was located"
PRINT "at the time of the last press and release. Press <Enter> if"
PRINT "you don't wish to wait a full 10 seconds."
PRINT

Presses% = MousePressInfo(0, Row%, Column%)      'Resets the internal
Releases% = MouseReleaseInfo(0, Row%, Column%)   'counters.
PRINT "Time left:";
CALL MousePointerOn
StartTime& = TIMER                          'Starting TIMER value
DO
    TimeLeft% = 10& - (TIMER - StartTime&)  'Calculate time left
    LOCATE , 11                             'Position cursor
    PRINT TimeLeft%;                        'Print TimeLeft value
    A$ = INKEY$                             'Check for a keypress
LOOP UNTIL TimeLeft% = 0 OR A$ = CHR$(13)   'Loop until Esc/timeout
PRINT
PRINT
PRINT "The left button was pressed"; MousePressInfo(0, Row%, Column%);
PRINT "times and was located at"; Row%; ","; Column%; "when it"
PRINT "was last pressed."
PRINT
PRINT "The left button was released"; MouseReleaseInfo(0, Row%, Column%);
PRINT "times and was located at"; Row%; ","; Column%; "when it"
PRINT "was last released."
PRINT
PRINT "Press <Enter> to proceed or <Esc> to quit."
GOSUB WaitForEscOrEnter

GOSUB ClearScreen
PRINT "We'll now the use MouseSetWindow routine to restrict the"
PRINT "movement of the mouse pointer to a rectangular area of the"
PRINT "screen. Press <Enter> to proceed or press <Esc> to quit."

LOCATE 5, 1
PRINT STRING$(1440, 219)            'Create a "blocked" area of the
FOR Row% = 8 TO 19                  ' screen. This helps to demo
    LOCATE Row%, 10                 ' the routine more effectively.
    PRINT STRING$(60, " ");
NEXT
CALL MousePointerOn                 'Pointer back on
CALL MouseSetWindow(8, 10, 19, 69)  'Define our window
GOSUB WaitForEscOrEnter             'Hmm. What does this do?
CALL MouseSetWindow(1, 1, ScreenRows%, ScreenCols%)

GOSUB ClearScreen
PRINT "The MouseMovement routine can tell you how far the mouse has"
PRINT "moved between calls. The results are returned in "; mickeys; "."
PRINT "There are about 200 mickeys per inch."
PRINT
PRINT "Each time you press the left mouse button, we'll show you how"
PRINT "far the mouse has moved since the last time the left button"
PRINT "was pressed."
PRINT
PRINT "Press <Enter> when you are ready to proceed to the next part of the"
PRINT "demo or press <Esc> to quit."
PRINT
PRINT "Mouse movement since last left button click:"
PRINT
PRINT "     Horizontal Mickeys: 0"
PRINT "       Vertical Mickeys: 0"

CALL MouseMovement(Rows%, Columns%)     'Reset the internal counters
CALL MousePointerOn                     'So we can see it
Rows% = 0                               'Zero our variables
Columns% = 0
DO
    DO
        CALL MouseGetStatus(Lb%, Rb%, Cb%, Row%, Column%)
        A$ = INKEY$
    LOOP UNTIL Lb% OR LEN(A$)
    IF Lb% THEN                              'If left button pressed
        CALL MouseMovement(Rows%, Columns%)  'How much has it moved?
        LOCATE 14, 25
        PRINT Rows%; "    "                  'Display the net changes
        LOCATE , 25
        PRINT Columns%; "    "
        CALL MouseWaitForRelease             'Wait for button release
    ELSE
        SELECT CASE A$                       'A key was pressed
            CASE CHR$(27)                    'Esc
                GOTO MouseTestExit
            CASE CHR$(13)                    'Enter
                EXIT DO
            CASE ELSE                        'Whoops
                BEEP
        END SELECT
    END IF
LOOP

GOSUB ClearScreen
PRINT "Using the MouseSetRatio routine, you can control the sensitiv-"
PRINT "ity of the mouse. It is used to adjust the ratio between the"
PRINT "physical movement of the mouse and the amount of movement"
PRINT "reflected by the mouse pointer on the screen."
PRINT
PRINT "The default setting is 8 mickeys per 8 pixels of horizontal"
PRINT "movement (1 mickey per pixel) and 16 mickeys per 8 pixels of"
PRINT "vertical movement (2 mickeys per pixel). In other words, the"
PRINT "mouse is twice as sensitive to horizontal movement than to"
PRINT "vertical. This is necessary to more closely match the"
PRINT "proportions of your display."

PRINT "We'll not make the mouse half as sensitive as it normally is."
PRINT "This means that you'll have to move the mouse twice as far in"
PRINT "order to move the pointer the same distance. Try it now."
PRINT "Press <Enter> to proceed or press <Esc> to quit."
CALL MousePointerOn
CALL MouseSetRatio(32, 16)              'Make half as sensitive
GOSUB WaitForEscOrEnter

PRINT
PRINT "We'll now make the mouse twice as sensitive as it normally"
PRINT "is. Try it now. Press <Enter> to proceed or <Esc> to quit."
CALL MouseSetRatio(8, 4)                'Make twice as sensitive
GOSUB WaitForEscOrEnter
CALL MouseSetRatio(16, 8)               'Back to normal

GOSUB ClearScreen
PRINT "Using the MouseSetExclusionArea routine, you can define an"
PRINT "area of the screen that the mouse pointer will made invisible"
PRINT "if moved into."
PRINT
PRINT "We've moved the mouse cursor to the upper-left corner of the"
PRINT "screen and drawn a block below. If you move the mouse pointer"
PRINT "into the block, the pointer will disappear until you turn it"
PRINT "back on again with the MousePointerOn routine."
PRINT
PRINT "Press <Enter> to proceed or press <Esc> to quit."
CALL MousePointerOn
CALL MouseSetPointer(1, 1)
CALL MouseSetExclusionArea(12, 10, 21, 70)
FOR Row% = 12 TO 21
    LOCATE Row%, 10
    PRINT STRING$(61, 219)
NEXT
GOSUB WaitForEscOrEnter             'Wait until they've seen enough
CALL MousePointerOn                 'Turn it back on

GOSUB ClearScreen
PRINT "MouseSaveState can be used to save the current mouse"
PRINT "characteristics such as locate, pointer definitions,"
PRINT "visibility, etc., so it can be restored at a later time with"
PRINT "the MouseRestoreState routine."
PRINT
PRINT "The current mouse state has just been saved. Move the mouse"
PRINT "around the screen. When you press <Enter>, the mouse state"
PRINT "will be restored. You can tell it worked correctly if the"
PRINT "mouse pointer is returned to its current locate. Press <Esc>"
PRINT "to quit."

CALL MousePointerOn
Success% = MouseSaveState%
IF NOT Success% THEN
   PRINT
   PRINT "Insufficient memory to save mouse state ... Press a key"
ELSE
   GOSUB WaitForEscOrEnter
   CALL MouseRestoreState
   PRINT
   PRINT "The mouse state has been restored. Press <Enter> to proceed"
   PRINT "or press <Esc> to quit."
END IF
GOSUB WaitForEscOrEnter

GOSUB ClearScreen
PRINT "Using the MouseSetEvent routine in conjunction with BASIC's"
PRINT "built-in 'ON UEVENT' function, we can build a mouse oriented"
PRINT "event trap. BASIC already has one for a joystick, the timer,"
PRINT "the keyboard, etc., so why not a mouse?? Only Microsoft knows"
PRINT "for sure."
PRINT
PRINT "A mouse event has been set up. It will be triggered when the"
PRINT "left button is pressed, the right button is released, or when"
PRINT "there is ANY mouse movement.  Other options are available,"
PRINT "but these are the only ones we'll demonstrate at this time."
PRINT
PRINT "You'll see a message at the bottom of the screen each time an"
PRINT "event occurs.  You can try it now by moving the mouse around"
PRINT "and pressing/releasing the left and right mouse buttons."
PRINT
PRINT "Press any key when you've seen enough."

PRINT STRING$(79, "=")
VIEW PRINT 18 TO 25                     'To handle scrolling data
CALL MousePointerOn                     'Turn on mouse pointer
CALL MouseSetEvent(19)                  '2 + 16
ON UEVENT GOSUB MouseEventHandler       'Point to an event hander
UEVENT ON                               'Turn on event trapping.

DO
    A$ = INKEY$                         'Wait for a key
EventCheckLabel:                        '/W will cause check for
LOOP UNTIL LEN(A$)                      ' events here.

UEVENT OFF                              'Turn off event trapping
CALL MouseCancelEvent                   'Turn our handler off.
VIEW PRINT                              'Back to normal

GOSUB ClearScreen
MouseTestExit:
PRINT "End of demonstration."
CALL MousePointerOff
END

ClearScreen:
  CALL MousePointerOff         'The cls overwrites the mouse pointer.
  CLS                          'So we have to turn it off, and CLS.
RETURN                         'We'll turn it back on again above

WaitForEscOrEnter:
  DO
     A$ = INKEY$
  LOOP UNTIL A$ = CHR$(13) OR A$ = CHR$(27)
  IF A$ = CHR$(27) THEN
     RETURN MouseTestExit       'If Esc, exit program
  END IF
RETURN

MouseEventHandler:
  'This subroutine used in conjunction with the MouseSetEvent and
  'UEVENT demonstration.

  CALL MouseGetEventInfo(EventFlag%, Lb%, Rb%, Cb%, Row%, Column%)
  CALL MousePointerOff          'To prevent mouse droppings
  PRINT "Mouse Event - ";
  IF EventFlag% AND 1 THEN      'We have to use multiple IF..THEN
     PRINT "Mouse Motion - ";   ' blocks here instead of a SELECT CASE
  END IF                        ' because it is possible for more than
  IF EventFlag% AND 2 THEN      ' one type of event to occur
     PRINT "Lb Pressed - ";     ' simultaneously.
  END IF
  IF EventFlag% AND 16 THEN     'If you are interested only in one
     PRINT "Rb Released -";     ' type of event at a time, then a
  END IF                        ' SELECT CASE structure would be more
  PRINT Row%; ","; Column%      ' appropriate.
  CALL MousePointerOn           'Back on
RETURN

