;			PUTFIELD.ASM
EXTRN	GET$LOC : FAR
EXTRN	SETPORT : FAR
EXTRN	GETSCR : FAR
STRDAT		equ     [bp+06]		;
KIND		equ	[bp+10]		;
ATTR		equ	[bp+14]		;
COL 		equ	[bp+18]		;
ROW    		equ	[bp+22]		;
					;
;-----------------------------------------------------------------------------
code	segment byte public
	assume	cs:code
SAY	proc	far			;
	public	SAY			;
	push	BP  			; save power's registers
	mov	BP,SP			; must begin every inline
	push	DS                      ; use these registers later
	push	ES                      ; so save them also
	push	SI			;
	push	DI			;
	jmp	START			;
;-----------------------------------------------------------------------------
; use base pointer bytes for temp registers - eliminates using DW or DB and
; and a lot of complex code to address them
;-----------------------------------------------------------------------------
TPE		db	0		;
COLR		db	0		;
STR_LTH		dw	00		;
STR_OFS		dw	00		;
syncprt		dw	00
scrseg		dw	00
;-----------------------------------------------------------------------------
;---------------------ESTABLISH LOCATION OF 1ST SCREEN POSITION---------------
;-----------------------------------------------------------------------------
START:	xor	bx,bx			;
	LDS	SI,ROW			; get starting row
	mov	al,DS:[SI]		; in ax
;
	LDS	SI,COL			; get start col
	mov	ah,DS:[SI]		; in bx
	call	GETSCR			; return ax send col=ah row=al
	mov	STR_OFS,ax		; SAVE screen offset 		ROW
;-----------------------------------------------------------------------------
; get kind of output and attribute or color
;-----------------------------------------------------------------------------
	LDS	SI,KIND			; what kind of entry
	mov	al,DS:[SI]		; in bx
	mov	TPE,al			; save KIND 		COL
					;
	LDS	SI,ATTR			; get color or attribute if mono
	mov	al,DS:[SI]		; in bx
	mov	COLR,al			; save ATTR  		COL
;-----------------------------------------------------------------------------
;-----------------------------SET STRING POSITION-----------------------------
;-----------------------------------------------------------------------------
	LES	DI,STRDAT		; get Basic String Handle
	push	ES:[DI]			; pass handle to power Basic routine
	call	GET$LOC			; POWER BASIC STRING LOCATOR
	mov	DS, dx			; returns segment in DX
	mov	SI, ax			; offset in AX
	mov	STR_LTH,cx		; length in CX - how convenient!
;-----------------------------------------------------------------------------
;  get screen type and hold as BP variables
;-----------------------------------------------------------------------------
	call	SETPORT			;
	mov	scrseg,dx		; video sync
	mov	ES,dx			; setup screen segment
	mov	syncprt,ax		;syncport
;-------------------------------;---------------------------------------------
; primary procedures
; display the full string
;-------------------------------;---------------------------------------------
	mov	DI,STR_OFS	; reclaim screen offset
	mov	cx,STR_LTH	; and string length
	mov	bl,COLR		; color of display
;-------------------------------;
w3:	mov	al,DS:[SI]	; get a key
	inc	SI		;
;-------------------------------;
	mov	bh,TPE		; type of string
	cmp	bh,0		; alpha numeric
	je	GO		;
	cmp	bh,1		; DATE __/__/__
	je	DTE		;
	cmp	bh,2		; PHONE 555-555-5555
	je	PHN		;
	cmp	bh,3		; INTEGER 12345
	je	GO		;
	cmp	bh,8		; TIME 12:12
	je	TME		;
	cmp	bh,9		; DEGREE 359 59"
	je	DGR		;
	cmp	bh,10		; ZIP 11111-2222
	je	ZIP		;
	cmp	bh,8		; FLOAT 555.55
	jb	PNT		;
;===============================;
GO:	cli			; disable interrupts
		push	ax	;
	mov	dx,syncprt	;
w1:	in	al,dx		; test for video retrace
	test	al,01		; is it lo
	jnz	short w1	; no
w2:	in	al,dx		; yes so test again
	test	al,01		;
	jz	short w2	; no
		pop	ax	;
	mov	ES:[DI],al	;
	inc	DI		;
	mov	ES:[DI],bl	; and send attribute to screen
	inc	DI		; next position
	loop	w3		; loop until count is 0
	sti			; enable interrupts
	jmp	ENDIT		;
;-------------------------------;
GO1:		push	ax	;
w4:	in	al,dx		; test for video retrace
	test	al,01		; is it lo
	jnz	short w4	; no
w5:	in	al,dx		; yes so test again
	test	al,01		;
	jz	short w5	; no
		pop	ax	;
	mov	ES:[DI],ah	; display special char on the screen
	inc	DI		; the al still has the original value
	mov	ES:[DI],bl	; obtained from the string
	inc	DI		;
	jmp	short GO	;
;===============================;
DTE:	cmp	cl,4		;
	je	short DTE1	;
	cmp	cl,2		;
	je	short DTE1	;
	jmp	GO		;
DTE1:	mov	ah,"/"		;
	jmp	GO1		;
;-------------------------------;
PHN:	cmp	cl,4		;
	je	short PHN1	;
	cmp	cl,7		;
	je	short PHN1	;
	jmp	GO		;
PHN1:	mov	ah,"-"		;
	jmp	GO1		;
;-------------------------------;
TME:	cmp	cl,2		;
	je	short TME1	;
	jmp	GO		;
TME1:	mov	ah,":"		;
	jmp	GO1		;
;-------------------------------;
ZIP:	cmp	cl,4		;
	je	short ZIP1	;
	jmp	GO		;
ZIP1:	mov	ah,"-"		;
	jmp	GO1		;
;-------------------------------;
DGR:	cmp	cl,2		;
	je	short DGR1	;
	jmp	GO		;
DGR1:	mov	ah,0F8h		; degree symbol
	jmp	GO1		;
;-------------------------------;
PNT:	sub	bh,3		; get decimal (type 5 -3 =2)
	cmp	cl,bh		; is cl=2 yet
	je	short PNT1	; yes, so print the decimal place
	jmp	GO		; no so print the value
PNT1:	mov	ah,"."		;
	jmp	GO1		;
;------------------------------------------------------------------------------
ENDIT:	cmp	bh,9		; DEGREE 0 0"
	jne	short DONE	;
	mov	al,34		; chr$(34)=(") minutes of arc
	mov	ES:[DI],al	;
	inc	DI		;
	mov	ES:[DI],bl	; and send attribute to screen
DONE:	pop	DI		; restore power registers
	pop	SI		;
	pop	ES		;
	pop	DS		;
	pop	BP		;
	retf	20		; we passed 5 variables (5*4)
SAY	endp			;
code	ends 			;
	end SAY			;
